image: docker:19.03

services:
  - docker:dind

stages:
  - build
  - test
  - push

variables:
  # use a faster driver
  DOCKER_DRIVER: overlay2

before_script:
    - apk add --no-cache bash coreutils curl diffutils findutils git jq

# Build the docker image
Build:
  stage: build
  script:
    - $CI_PROJECT_DIR/.gitlab-ci/build.sh

# Test the docker image
Test:
  stage: test
  script:
    # Comment this out when testing locally with gitlab-runner
    # ----------
    - docker pull $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA $DOCKERHUB_IMAGE_NAME:latest
    # ----------
    - export TMPDIR=$CI_PROJECT_DIR
    - $CI_PROJECT_DIR/tests/test.sh

# Tag the "master" branch as "latest"
# Push latest:
#   stage: push
#   only:
#     # only "master" should be tagged "latest"
#     - master
#   script:
#     - $CI_PROJECT_DIR/.gitlab-ci/push-latest.sh

# Tag the image with the Git tag
Push tagged:
  stage: push
  only:
    # we want this job to be run on tags only
    - tags
  script:
    - $CI_PROJECT_DIR/.gitlab-ci/push-tagged.sh
